//note 36 //D16 //P16 bass drum 
//note 37 //D15 //P13 hi congas
//note 38 //D8  //P11 low congas
//note 39 //D14 //P12 muted congas
//note 40 //D12 //P3 snare
//note 41 //D11 //P6 hi tom 
//note 42 //D10 //P7 low tom
//note 43 //D9  //P10 claves 
//note 44 //D18 //P5 cymb 
//note 45 //D19 //P8 cowbell
//note 46 //D17 //P4 hi hat
//note 47 //D7  //P1-P2 ohh
//note 48 //D6  //P15 rimshot
//D5 ACC velocity >= 110

#include <MIDI.h> 
#include <EEPROM.h>
const byte sel = 2; //button channel select
const byte acc = 5;
byte chn;
int address = 1; // mem chn
MIDI_CREATE_DEFAULT_INSTANCE();

void setup() 
{  
pinMode (sel, INPUT_PULLUP); // chn bt
pinMode (acc, OUTPUT); // ACC
pinMode (6, OUTPUT);  // P15 rimshot
pinMode (7, OUTPUT);  // P1-P2 open hi hat
pinMode (8, OUTPUT);  // P11 low congas
pinMode (9, OUTPUT);  // P10 claves
pinMode (10, OUTPUT); // P7 low tom
pinMode (11, OUTPUT); // P6 hi tom
pinMode (12, OUTPUT); // P3 snare
pinMode (14, OUTPUT); // P12 muted congas
pinMode (15, OUTPUT); // P13 hi congas
pinMode (16, OUTPUT); // P16 bass drum
pinMode (17, OUTPUT); // P4 hi hat
pinMode (18, OUTPUT); // P5 cymb
pinMode (19, OUTPUT); // P8 cowbell


chn = EEPROM.read(address);
MIDI.setHandleNoteOn(handleNoteOn);
MIDI.setHandleNoteOff(handleNoteOff);
delay (3000);

if (chn == 0 || chn > 16)
{
chn = 1;
EEPROM.write(address, chn);
delay(1000);
MIDI.begin(chn);
start (chn);
}
else
{
delay(1000);
MIDI.begin(chn);
bar (chn);
}  
}


void loop() 
{
boolean schn = digitalRead(sel); // btn channnel select
MIDI.read();

if (schn == LOW)
      {
      chn+=1;
      if (chn <= 16)
      {
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar (chn);
      }
      if (chn >= 17)
      {
      chn = 1;
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar(chn);
      }
      }
}

void handleNoteOn(byte channel, byte note, byte velocity)
{
  if (note == 36 && velocity >= 10 && velocity <= 109) //bass drum  
  {digitalWrite(16, HIGH);}
  if (note == 36 && velocity >= 110) //BASS DRUM
  {digitalWrite(16, HIGH); digitalWrite(acc, HIGH); }
  
  if (note == 37 && velocity >= 10 && velocity <= 109) //hi congas 
  {digitalWrite(15, HIGH);}
  if (note == 37 && velocity >= 110) //HI CONGAS 
  { digitalWrite(15, HIGH); digitalWrite(acc, HIGH); }
 
  if (note == 38 && velocity >= 10 && velocity <= 109) //low congas
  { digitalWrite(8, HIGH);  }
  if (note == 38 && velocity >= 110) //LOW CONGAS
  {  digitalWrite(8, HIGH); digitalWrite(acc, HIGH);  }

  if (note == 39 && velocity >= 10 && velocity <= 109) //muted congas
  {  digitalWrite(14, HIGH);  }
  if (note == 39 && velocity >= 110) //MUTED CONGAS
  {  digitalWrite(14, HIGH);  digitalWrite(acc, HIGH);  }
 
  if (note == 40 && velocity >= 10 && velocity <= 109) //snare
  {  digitalWrite(12, HIGH);  }
  if (note == 40 && velocity >= 110) //SNARE
  {  digitalWrite(12, HIGH);  digitalWrite(acc, HIGH);  }
 
  if (note == 41 && velocity >= 10 && velocity <= 109) //hi tom
  {  digitalWrite(11, HIGH);  }
  if (note == 41 && velocity >= 110) //HI TOM
  {  digitalWrite(11, HIGH);  digitalWrite(acc, HIGH);  }
  
  if (note == 42 && velocity >= 10 && velocity <= 109) //low tom
  {  digitalWrite(10, HIGH);  }
  if (note == 42 && velocity >= 110) //LOW TOM
  {  digitalWrite(10, HIGH);  digitalWrite(acc, HIGH);  }
 
  if (note == 43 && velocity >= 10 && velocity <= 109) //claves
  {  digitalWrite(9, HIGH);  }
  if (note == 43 && velocity >= 110) //CLAVES
  {  digitalWrite(9, HIGH);  digitalWrite(acc, HIGH);  }

  if (note == 44 && velocity >= 10 && velocity <= 109) //cymb
  {  digitalWrite(18, HIGH);  }
  if (note == 44 && velocity >= 110) //CYMB
  {  digitalWrite(18, HIGH);  digitalWrite(acc, HIGH);  }
  
  if (note == 45 && velocity >= 10 && velocity <= 109) //cowbell
  {  digitalWrite(19, HIGH);  }
  if (note == 45 && velocity >= 110) //COWBELL
  {  digitalWrite(19, HIGH);  digitalWrite(acc, HIGH);  }
   
   if (note == 46 && velocity >= 10 && velocity <= 109) //hihat
  {  digitalWrite(17, HIGH);  }
  if (note == 46 && velocity >= 110) //HIHAT
  {  digitalWrite(17, HIGH);  digitalWrite(acc, HIGH);  }
  
  if (note == 47 && velocity >= 10 && velocity <= 109) //openhihat
  {  digitalWrite(7, HIGH);  }
  if (note == 47 && velocity >= 110) //OPENHIHAT
  {  digitalWrite(7, HIGH);  digitalWrite(acc, HIGH);  }
   
   if (note == 48 && velocity >= 10 && velocity <= 109) //rimshot
  {  digitalWrite(6, HIGH);  }
  if (note == 48 && velocity >= 110) //RIMSHOT
  {  digitalWrite(6, HIGH);  digitalWrite(acc, HIGH);  }
  
  }
  void handleNoteOff(byte channel, byte note, byte velocity)
{
   if (note == 36) // && velocity <= 9) //bass drum
   {   digitalWrite(16, LOW);   digitalWrite(acc, LOW);   }
  
   if (note == 37) // && velocity <= 9) //hi congas
   {   digitalWrite(15, LOW);   digitalWrite(acc, LOW);   }
  
   if (note == 38) // && velocity <= 9) //low congas
   {   digitalWrite(8, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 39) // && velocity <= 9) //muted congas
   {   digitalWrite(14, LOW);   digitalWrite(acc, LOW);   }
  
   if (note == 40) // && velocity <= 9) //snare
   {   digitalWrite(12, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 41) // && velocity <= 9) //hi tom
   {   digitalWrite(11, LOW);   digitalWrite(acc, LOW);   }
  
   if (note == 42) // && velocity <= 9) //low tom
   {   digitalWrite(10, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 43) // && velocity <= 9) //claves
   {   digitalWrite(9, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 44) // && velocity <= 9) //cymb
   {   digitalWrite(18, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 45) // && velocity <= 9) //cowbell
   {   digitalWrite(19, LOW);   digitalWrite(acc, LOW);   }
    
   if (note == 46) // && velocity <= 9) //hihat
   {   digitalWrite(17, LOW);   digitalWrite(acc, LOW);   }
   
   if (note == 47) // && velocity <= 9) //openhihat
   {   digitalWrite(7, LOW);   digitalWrite(acc, LOW);   }
 
   if (note == 48) // && velocity <= 9) //rimshot
   {   digitalWrite(6, LOW);   digitalWrite(acc, LOW);   }
   
}
void start(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(16, HIGH);
	digitalWrite(13, HIGH);
    delay(50);
    digitalWrite(16, LOW);
	digitalWrite(13, LOW);
    delay(400);
    loop();
    }
}
void bar(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(16, HIGH);
	digitalWrite(13, HIGH);
    delay(50);
    digitalWrite(16, LOW);
	digitalWrite(13, LOW);
    delay(400);
    }
}
